//----------------------------------------------------------------------//
// EyeTra																//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <math.h>
#include <memory>
#include <Vcl.HtmlHelpViewer.hpp>
#include <System.StrUtils.hpp>
#include "usr_wic.h"
#include "Unit1.h"
#include "About.h"

#pragma link "Vcl.HTMLHelpViewer"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TParaTraForm *ParaTraForm;

//---------------------------------------------------------------------------
__fastcall TParaTraForm::TParaTraForm(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormCreate(TObject *Sender)
{
	Initialized = false;

	Timer1->Enabled = false;
	Timer2->Enabled = false;

	IniFile  = new UsrIniFile(ChangeFileExt(Application->ExeName, ".INI"));

	CharFont = IniFile->ReadFontInf("CharFont");
	ObjBuff  = new Graphics::TBitmap();

	MotionList = new TStringList();
	vDef = 4;
	vX = 0;
	vY = 0;
	vS = 0;
	vA = 0;
	Scaling = false;

	ImgComboBox->Items->Text =
		"hg\r\n"
		"d`[g\r\n"
		"ɐ}\r\n"
		"ɐ}(F)\r\n"
		"Ђ炪(_)\r\n"
		"J^Ji(_)\r\n"
		"p(_)\r\n"
		"w蕶\r\n"
		"w摜\r\n";

	MoveComboBox->Items->Text =
		"ʒuŒ\r\n"
		"Oړ\r\n"
		"O + Eړ\r\n"
		"O + ㉺ړ\r\n"
		"O + E + ㉺ړ\r\n"
		"OEE ~ړ\r\n"
		"OE㉺ ~ړ\r\n"
		" ~ړ\r\n"
		"OEE ړ\r\n"
		"OE㉺ ړ\r\n"
		" ړ\r\n"
		"OEEE㉺ _ړ\r\n";

	Application->HelpFile = ChangeFileExt(Application->ExeName, ".CHM");
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormShow(TObject *Sender)
{
	IniFile->LoadFormPos(this, Screen->Width, Screen->Height);
	OrgWinState = WindowState;

	UnicodeString sct = "Option";
	TrackBar_S0->Position	= minInterSize = IniFile->ReadInteger(sct, "MinInterSize", 120);
	TrackBar_S1->Position	= maxInterSize = IniFile->ReadInteger(sct, "MaxInterSize", 360);
	TrackBar_GW->Position	= IniFile->ReadInteger(sct, "GridWidth",	100);
	CheckBox_G->Checked 	= IniFile->ReadBool(   sct, "ShowGrid",		false);
	MoveComboBox->ItemIndex = IniFile->ReadInteger(sct, "MoveMode",		2);
	CheckBox_RT->Checked	= IniFile->ReadBool(   sct, "ImageRT",		false);
	CheckBox_SC->Checked	= IniFile->ReadBool(   sct, "ImageSC",		true);
	SpeedGroup->ItemIndex	= IniFile->ReadInteger(sct, "Speed",		0);
	TimeEdit->Text			= IniFile->ReadInteger(sct, "TrainingTime",	180);

	col_fg	 = (TColor)IniFile->ReadInteger(sct, "ColorFg", 	clBlack);
	col_bg	 = (TColor)IniFile->ReadInteger(sct, "ColorBg", 	clMoneyGreen);
	col_grid = (TColor)IniFile->ReadInteger(sct, "ColorGrid",	clLtGray);
	CharFont->Color = col_fg;
	Color			= col_bg;

	ImgComboBox->ItemIndex			 = IniFile->ReadInteger(sct, "ImageIndex",	0);
	ImageSizeEdit->Text = maxImgSize = IniFile->ReadInteger(sct, "CharSize",	120);
	CharEdit->Text					 = IniFile->ReadString( sct, "Character",	"L");
	ImageFile						 = IniFile->ReadString( sct, "ImageFile");

	maxMovWidth = std::min(Screen->Width*2/3, Screen->Height*3/4);

	::PostMessage(Handle, WM_FORM_SHOWED, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::WmFormShowed(TMessage &msg)
{
	TrackBar_S0Change(NULL);
	SetObjImg();
	Initialized = true;
	Repaint();
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SaveFormPos(this);

	UnicodeString sct = "Option";
	IniFile->WriteInteger(sct, "MinInterSize",	TrackBar_S0->Position);
	IniFile->WriteInteger(sct, "MaxInterSize",	TrackBar_S1->Position);
	IniFile->WriteInteger(sct, "GridWidth",		TrackBar_GW->Position);
	IniFile->WriteBool(	  sct, "ShowGrid",		CheckBox_G->Checked);
	IniFile->WriteInteger(sct, "MoveMode",		MoveComboBox->ItemIndex);
	IniFile->WriteBool(	  sct, "ImageRT",		CheckBox_RT->Checked);
	IniFile->WriteBool(   sct, "ImageSC",		CheckBox_SC->Checked);
	IniFile->WriteInteger(sct, "Speed",			SpeedGroup->ItemIndex);
	IniFile->WriteInteger(sct, "ImageIndex",	ImgComboBox->ItemIndex);
	IniFile->WriteString( sct, "CharSize",		maxImgSize);
	IniFile->WriteString( sct, "Character",		CharEdit->Text);
	IniFile->WriteString( sct, "ImageFile",		ImageFile);
	IniFile->WriteString( sct, "TrainingTime",	TimeEdit->Text);
	IniFile->WriteInteger(sct, "ColorFg",		col_fg);
	IniFile->WriteInteger(sct, "ColorBg",		col_bg);
	IniFile->WriteInteger(sct, "ColorGrid",		col_grid);
	IniFile->WriteFontInf("CharFont", CharFont);

	IniFile->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormDestroy(TObject *Sender)
{
	delete MotionList;
	delete CharFont;
	delete ObjBuff;
	delete IniFile;
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormResize(TObject *Sender)
{
	Repaint();
}

//---------------------------------------------------------------------------
//ʕ`
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormPaint(TObject *Sender)
{
	if (!Initialized) return;

	//iq
	if (CheckBox_G->Checked) {
		Canvas->Pen->Width = 1;
		Canvas->Pen->Style = psSolid;
		Canvas->Pen->Color = col_grid;
		int dx = TrackBar_GW->Position;
		for (int x=dx; x<ClientWidth; x+=dx) {
			Canvas->MoveTo(x, 0);
			Canvas->LineTo(x, ClientHeight);
		}
	}

	//]
	int obj_sz = ObjBuff->Width;
	std::unique_ptr<Graphics::TBitmap> rot_bmp(new Graphics::TBitmap());
	rot_bmp->SetSize(obj_sz*1.42, obj_sz*1.42);
	TCanvas *tmp_cv = rot_bmp->Canvas;
	tmp_cv->Brush->Color = col_bg;
	tmp_cv->FillRect(Rect(0,0, rot_bmp->Width, rot_bmp->Height));

	double r	 = sqrt(obj_sz*obj_sz * 2.0) / 2.0;
	double angle = (M_PI * A / 180) - (M_PI_4 + M_PI_2);
	POINT  p[3];
	int cx = rot_bmp->Width/2;
	int cy = rot_bmp->Width/2;
	p[0].x = cx + (int)(cos(angle) * r + 0.5);
	p[0].y = cy + (int)(sin(angle) * r + 0.5);
	angle += M_PI_2;
	p[1].x = cx + (int)(cos(angle) * r + 0.5);
	p[1].y = cy + (int)(sin(angle) * r + 0.5);
	angle += M_PI;
	p[2].x = cx + (int)(cos(angle) * r + 0.5);
	p[2].y = cy + (int)(sin(angle) * r + 0.5);
	::PlgBlt(rot_bmp->Canvas->Handle, p, ObjBuff->Canvas->Handle, 0, 0, obj_sz, obj_sz, NULL, 0, 0);

	//XP[O
	std::unique_ptr<Graphics::TBitmap> obj_bmp(new Graphics::TBitmap());
	double sr = (CheckBox_SC->Checked? (1.0 * minInterSize / S) : 1.0) / 2.0;
	WIC_resize_image(rot_bmp.get(), obj_bmp.get(), sr, 0,0, 3);
	obj_bmp->Transparent = true;

	//`
	int px	= ClientWidth/2  + X;
	int py	= ClientHeight/2 + Y;
	int ofs = obj_bmp->Width/2;
	Canvas->Draw(px - S/2 - ofs, py - ofs, obj_bmp.get());
	Canvas->Draw(px + S/2 - ofs, py - ofs, obj_bmp.get());
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::ImgObjChange(TObject *Sender)
{
	SetObjImg();
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::ImageSizeEditChange(TObject *Sender)
{
	maxImgSize = ImageSizeEdit->Text.ToIntDef(72);
	SetObjImg();
}

//---------------------------------------------------------------------------
//C[Wݒ
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::SetObjImg()
{
	int i_sz = maxImgSize * 2;
	ObjBuff->SetSize(i_sz, i_sz);
	TRect obj_rc = Rect(0,0, i_sz,i_sz);
	TCanvas *obj_cv = ObjBuff->Canvas;
	obj_cv->Brush->Color = col_bg;
	obj_cv->FillRect(obj_rc);
	int w5	= i_sz/5;
	int w8	= i_sz/8;
	int mgn = 4;
	TRect tmp_rc;

	TColor col_cmp;	//F
	{
		int cref = ColorToRGB(col_fg);
		int r = GetRValue(cref), g = GetGValue(cref), b = GetBValue(cref);
		int x = std::max(r, std::max(g, b)) + std::min(r, std::min(g, b));
		r = x-r; g = x-g; b = x-b;
		col_cmp = TColor(RGB(r,g,b));
	}

	switch (ImgComboBox->ItemIndex) {
	case 0:	//hg
		obj_cv->Brush->Color = col_fg;
		obj_cv->Ellipse(obj_rc);
		InflateRect(obj_rc, -w5, -w5);
		obj_cv->Brush->Color = col_bg;
		obj_cv->Ellipse(obj_rc);
		InflateRect(obj_rc, -w5, -w5);
		OffsetRect(obj_rc, w5*2, 0);
		obj_rc.Left -= i_sz/10;
		obj_cv->FillRect(obj_rc);
		break;
	case 1:	//d`[g
		InflateRect(obj_rc, -2, -2);
		obj_cv->Brush->Color = col_fg;
		obj_cv->FillRect(obj_rc);
		obj_rc.SetHeight(w5);
		OffsetRect(obj_rc, w5, w5);
		obj_cv->Brush->Color = col_bg;
		obj_cv->FillRect(obj_rc);
		OffsetRect(obj_rc, 0, w5*2);
		obj_cv->FillRect(obj_rc);
		break;
	case 2: case 3:	//ɐ}
		InflateRect(obj_rc, -mgn, -mgn);
		tmp_rc = obj_rc;
		i_sz = tmp_rc.Width();
		obj_cv->Pen->Style	 = psSolid;
		obj_cv->Pen->Width	 = 4;
		obj_cv->Pen->Color	 = col_fg;
		obj_cv->Brush->Color = col_fg;
		obj_cv->Ellipse(tmp_rc);
		obj_cv->Brush->Color = (ImgComboBox->ItemIndex==3)? col_cmp : col_bg;
		obj_cv->Pie(tmp_rc.Left,tmp_rc.Top, tmp_rc.Right,tmp_rc.Bottom, tmp_rc.Left+i_sz/2,tmp_rc.Top, tmp_rc.Left+i_sz/2,tmp_rc.Bottom);

		tmp_rc.Top	 += 4;
		tmp_rc.Bottom = i_sz/2;
		InflateRect(tmp_rc, -i_sz/4, 0);
		obj_cv->Pen->Style	 = psClear;
		obj_cv->Ellipse(tmp_rc);

		tmp_rc.Top	  = tmp_rc.Bottom;
		tmp_rc.Bottom = obj_rc.Bottom;
		obj_cv->Brush->Color = col_fg;
		obj_cv->Ellipse(tmp_rc);

		tmp_rc = Rect(0,0,w8,w8);
		OffsetRect(tmp_rc, i_sz/2-w8/2, i_sz/4-w8/2);
		obj_cv->Ellipse(tmp_rc);
		OffsetRect(tmp_rc, 0, i_sz/2);
		obj_cv->Brush->Color = (ImgComboBox->ItemIndex==3)? col_cmp : col_bg;
		obj_cv->Ellipse(tmp_rc);
		break;

	case 8:	//w摜
		{
			std::unique_ptr<Graphics::TBitmap> bmp_buf(new Graphics::TBitmap());
			if (WIC_load_image(ImageFile, bmp_buf.get())) {
				bmp_buf->Transparent = true;
				obj_cv->StretchDraw(obj_rc, bmp_buf.get());
			}
			else {
				obj_cv->Brush->Color = col_fg;
				obj_cv->FillRect(obj_rc);
				InflateRect(obj_rc, -4, -4);
				obj_cv->Brush->Color = clLtGray;
				obj_cv->FillRect(obj_rc);
				obj_cv->Font->Assign(Font);
				obj_cv->Font->Size = obj_cv->Font->Size * 3;
				obj_cv->Font->Color = clWindowText;
				UnicodeString msg = "Ȃ";
				obj_cv->TextOut((i_sz - obj_cv->TextWidth(msg))/2, (i_sz- obj_cv->TextHeight(msg))/2, msg);
			}
		}
		break;

	//
	default:
		obj_cv->Brush->Style = bsClear;
		CharFont->Height = i_sz;
		obj_cv->Font->Assign(CharFont);
		{
			UnicodeString c;
			switch (ImgComboBox->ItemIndex) {
			case 4:
				c = UnicodeString("ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂").SubString(Random(46)+1, 1);
				break;
			case 5:
				c = UnicodeString("ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~").SubString(Random(46)+1, 1);
				break;
			case 6:
				c = UnicodeString("`abcdefghijklmnopqrstuvwxy").SubString(Random(26)+1, 1);
				break;
			case 7:
				c = CharEdit->Text;
				break;
			}
			obj_cv->TextRect(obj_rc, 0, 0, c);
		}
		break;
	}

	Invalidate();
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::SetObjPos(int x, int y, int s, int a)
{
	X = x;
	Y = y;
	S = s;
	A = a;
	Repaint();
}

//---------------------------------------------------------------------------
//ړf[^쐬
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::MoveObject(WideChar prm, int step)
{
	int s_k  = (SpeedGroup->ItemIndex==1)? 2 : (SpeedGroup->ItemIndex==2)? 4 : 1;

	switch (prm) {
	case 'S':
		for (int i=0; i<step; i++) {
			A += vA * s_k;
			MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,0"), X,Y,S,A));
		}
		return;

	case 'H': {
			int hp = (maxInterSize - minInterSize) / 2 + minInterSize;
			if (S<hp) {
				while (S<hp) {
					S += 4;
					A += vA * s_k;
					MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,0"), X,Y,S,A));
				}
			}
			else if (S>hp) {
				while (S>hp) {
					S -= 4;
					A += vA * s_k;
					MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,0"), X,Y,S,A));
				}
			}
		}
		return;

	case 'R':
		if		(vX<0)  vX = -vX;
		else if (vX==0) vX = vDef;
		break;
	case 'L':
		if		(vX>0)  vX = -vX;
		else if (vX==0) vX = -vDef;
		break;
	case 'C':
		if ((vX<0 && X<0) || (vX>0 && X>0)) vX = -vX;
		break;
	case 'D':
		if		(vY<0)  vY = -vY;
		else if (vY==0) vY = vDef;
		break;
	case 'U':
		if		(vY>0)  vY = -vY;
		else if (vY==0) vY = -vDef;
		break;
	case 'M':
		if ((vY<0 && Y<0) || (vY>0 && Y>0)) vY = -vY;
		break;
	case 'W':
		if		(vS<0)  vS = -vS;
		else if (vS==0) vS = 1;
		break;
	case 'T':
		if		(vS>0)  vS = -vS;
		else if (vS==0) vS = -1;
		break;
	}

	int dS = vS * s_k;
	int dX = vX * s_k;
	int dY = vY * s_k;
	int dA = vA * s_k;

	bool quit = false;
	while (!quit) {
		S += dS;
		X += dX;
		Y += dY;
		A += dA;
		int flag = 0;

		if (prm=='C' && ((vX>0 && X>0) || (vX<0 && X<0))) {
			X = 0;  vX = 0;		quit = true;
		}
		if (prm=='M' && ((vY>0 && Y>0) || (vY<0 && Y<0))) {
			Y = 0;  vY = 0;		quit = true;
		}

		if (X>maxMovWidth/2) {
			X = maxMovWidth/2;	if (prm=='R') quit = true;
		}
		else if (X<-maxMovWidth/2) {
			X = -maxMovWidth/2;	if (prm=='L') quit = true;
		}

		if (Y>maxMovWidth/2) {
			Y = maxMovWidth/2;	if (prm=='D') quit = true;
		}
		else if (Y<-maxMovWidth/2) {
			Y = -maxMovWidth/2;	if (prm=='U') quit = true;
		}

		if (S>maxInterSize) {
			S = maxInterSize;
			if (prm=='W') {
				vS = 0;	quit = true;
			}
		}
		else if (S<minInterSize) {
			S = minInterSize;
			if (prm=='T') {
				vS = 0; flag = 1;	quit = true;
			}
		}

		MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,%d"), X,Y,S,A, IsChar? flag : 0));
	}

	//EFCg
	for (int i=0; i<IMG_FPS/s_k; i++) {
		A += vA * s_k;
		MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,0"), X,Y,S,A));
	}
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::MoveObject(UnicodeString prm)
{
	while (!prm.IsEmpty()) {
		MoveObject(prm[1]);
		prm.Delete(1, 1);
	}
}

//---------------------------------------------------------------------------
//~^
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::OrbitalObject(bool x_sw, bool y_sw, bool s_sw, bool m_sw, bool rev, int n)
{
	int r_w = maxMovWidth/2;
	int r_s = (maxInterSize - minInterSize)/2;
	int s_k = (SpeedGroup->ItemIndex==1)? 2 : (SpeedGroup->ItemIndex==2)? 4 : 1;

	double s_d = (SpeedGroup->ItemIndex==1)? 1.0 : (SpeedGroup->ItemIndex==2)? 2.0 : 0.5;
	double deg1 = -90;
	double deg2 = 0;
	int cyc = (int)(360/s_d);

	for (int rpt=0; rpt<n; rpt++) {
		for (int i=0; i<cyc; i++) {
			double ang1 = M_PI * deg1 / 180;
			double ang2 = M_PI * deg2 / 180;
			if (m_sw) {
				if (x_sw) X = (int)(cos(ang1) * r_w + 0.5);
				if (y_sw) Y = (int)(cos(x_sw? (ang2+M_PI_2) : ang1) * r_w + 0.5);
				if (s_sw) S = (int)(sin(ang2) * r_s + 0.5) + minInterSize + r_s;
			}
			else {
				if (x_sw) X = (int)(cos(ang1) * r_w + 0.5);
				if (y_sw) Y = (int)(cos(ang1 + (x_sw? M_PI_2 : 0.0)) * r_w + 0.5);
				if (s_sw) S = (int)(sin(ang1) * r_s + 0.5) + minInterSize + r_s;
			}
			A += vA * s_k;
			MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,0"), X,Y,S,A));

			if (rev) deg1 += s_d; else deg1 -= s_d;
			if (rev) deg2 += s_d*2; else deg2 -= s_d*2;
		}
	}
}

//---------------------------------------------------------------------------
//_
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::RandomObject(int step)
{
	int s_k = (SpeedGroup->ItemIndex==1)? 2 : (SpeedGroup->ItemIndex==2)? 4 : 1;

	for (int i=0; i<step; i++) {
		int flag = 0;
		S += vS * s_k;
		X += vX * s_k;
		Y += vY * s_k;
		A += vA * s_k;

		if ((vX>0 && X>maxMovWidth/2) ||  (vX<0 && X<-maxMovWidth/2)) {
			vX = -vX;
			maxMovWidth = ClientWidth * (0.4 + Random(4)/10.0);
			if (Random(3)==0) vS = -vS;
			if (Random(3)==0) vA = -vA;
		}

		if ((vY>0 && Y>maxMovWidth/2) || (vY<0 && Y<-maxMovWidth/2)) {
			vY = -vY;
			maxMovWidth = ClientHeight * (0.4 + Random(4)/10.0);
			if (Random(3)==0) vS = -vS;
			if (Random(3)==0) vA = -vA;
		}

		if ((vS>0 && S>maxInterSize) || (vS<0 && S<minInterSize)) {
			vS = -vS;
			flag = 1;
			if (Random(3)==0) vA = -vA;
		}
		else if (Random(IMG_FPS * 10)==0) {
			vS = -vS;
		}

		MotionList->Add(UnicodeString().sprintf(_T("%d,%d,%d,%d,%d"), X,Y,S,A, IsChar? flag : 0));
	}
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::TrackBar_S0Change(TObject *Sender)
{
	minInterSize = TrackBar_S0->Position;
	SetObjPos(0, 0, minInterSize, 0);
	TrackBar_S0->Hint = minInterSize;
	TrackBar_S1->Hint = EmptyStr;
	TrackBar_S1->Min  = minInterSize + 50;
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::TrackBar_S1Change(TObject *Sender)
{
	maxInterSize = TrackBar_S1->Position;
	SetObjPos(0, 0, maxInterSize, 0);
	TrackBar_S1->Hint = maxInterSize;
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::TrackBar_S0Enter(TObject *Sender)
{
	TrackBar_S0Change(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::TrackBar_S1Enter(TObject *Sender)
{
	TrackBar_S1Change(NULL);
}

//---------------------------------------------------------------------------
//摜w
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::ImageBtnClick(TObject *Sender)
{
	UnicodeString flt_str;
	flt_str  = "rbg}bv (*.bmp)|*.bmp";
	flt_str += "|PNGt@C(*.PNG)|*.PNG";
	flt_str += "|GIFt@C(*.GIF)|*.GIF";
	flt_str += "|JPEGt@C(*.JPG)|*.JPG;*.JPE;*.JPEG";
	OpenPictureDialog1->Filter = flt_str;

	UnicodeString ext = ExtractFileExt(ImageFile);
	if (!ext.IsEmpty()) {
		OpenPictureDialog1->FilterIndex =
			SameText(ext, ".bmp")? 	1 :
			SameText(ext, ".jpg")?	2 :
			SameText(ext, ".png")?	3 :
			SameText(ext, ".gif")?	4 : 1;
	}

	OpenPictureDialog1->Title = "摜̎w";
	OpenPictureDialog1->InitialDir = ExtractFilePath(ImageFile);
	OpenPictureDialog1->FileName   = ImageFile;
	if (OpenPictureDialog1->Execute()) {
		ImageFile = OpenPictureDialog1->FileName;
		SetObjImg();
	}
}

//---------------------------------------------------------------------------
//tHg̎w
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FontBtnClick(TObject *Sender)
{
	FontDialog1->Font->Assign(CharFont);
	if (FontDialog1->Execute()) {
		CharFont->Assign(FontDialog1->Font);
		CharFont->Color = col_fg;
		SetObjImg();
	}
}

//---------------------------------------------------------------------------
//F̎w
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::ColorBtnClick(TObject *Sender)
{
	int tag = ((TComponent*)Sender)->Tag;
	ColorDialog1->Color = (tag==0)? col_fg : (tag==1)? col_bg : col_grid;
	if (ColorDialog1->Execute()) {
		switch (tag) {
		case 0: col_fg	 = ColorDialog1->Color; break;
		case 1: col_bg	 = ColorDialog1->Color; break;
		case 3: col_grid = ColorDialog1->Color; break;
		}

		CharFont->Color = col_fg;
		Color			= col_bg;
		SetObjImg();
	}
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::TrackBar_GWChange(TObject *Sender)
{
	TrackBar_GW->Hint = TrackBar_GW->Position;
	Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::ImgOptChanged(TObject *Sender)
{
	Repaint();
}

//---------------------------------------------------------------------------
//Jn
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::StartActionExecute(TObject *Sender)
{
	//----------------------
	//ړf[^쐬
	//----------------------
	MotionList->Clear();
	X = Y = A = 0;
	S = minInterSize;
	vX = vY = vS = 0;
	int total_stp = IMG_FPS * TimeEdit->Text.ToIntDef(180);

	//0.5bҋ@
	vA = 0;	MoveObject('S', IMG_FPS/2);
	vA = CheckBox_RT->Checked? 1 : 0;

	switch (MoveComboBox->ItemIndex) {
	case  0:	//ʒuŒ
		MoveObject('S', total_stp);
		break;
	case  1:	//O
		MoveObject("WTWT");	vA = -vA;
		MoveObject("WTWT"); vA = -vA;
		break;
	case  2:	//O + E
		MoveObject("WTW");	vX = 4;	MoveObject("RLRC");
		MoveObject("T");	vX = 4;	MoveObject("RLRC");
		vA = -vA;
		MoveObject("WTW");	vX = 4;	MoveObject("RLRC");
		MoveObject("T");	vX = 4;	MoveObject("RLRC");
		vA = -vA;
		break;
	case  3:	//O + ㉺
		MoveObject("WTW");	vY = 4;	MoveObject("UDUM");
		MoveObject("T");	vY = 4;	MoveObject("UDUM");
		vA = -vA;
		MoveObject("WTW");	vY = 4;	MoveObject("UDUM");
		MoveObject("T");	vY = 4;	MoveObject("UDUM");
		vA = -vA;
		break;
	case  4:	//O + E + ㉺
		MoveObject("WTW");	vX = 4;	MoveObject("RLRC"); vY = 4;	MoveObject("UDUM");
		MoveObject("T");	vX = 4;	MoveObject("RLRC"); vY = 4;	MoveObject("UDUM");
		vA = -vA;
		MoveObject("WTW");	vX = 4;	MoveObject("RLRC"); vY = 4;	MoveObject("UDUM");
		MoveObject("T");	vX = 4;	MoveObject("RLRC"); vY = 4;	MoveObject("UDUM");
		vA = -vA;
		break;

	case  5:	//OEE ~ړ
		OrbitalObject(true, false, true, false, false, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		OrbitalObject(true, false, true, false, true,  3);	MoveObject('S', IMG_FPS);	vA = -vA;
		break;
	case  6:	//OE㉺ ~ړ
		OrbitalObject(false, true, true, false, false, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		OrbitalObject(false, true, true, false, true,  3);	MoveObject('S', IMG_FPS);	vA = -vA;
		break;
	case  7:	// ~ړ
		MoveObject("DW");
		OrbitalObject(true, true, false, false, false, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		MoveObject("T");
		OrbitalObject(true, true, false, false, true, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		break;

	case  8:	//OEE ړ
		MoveObject('H');
		OrbitalObject(true, false, true, true, true,  3);	MoveObject('S', IMG_FPS);	vA = -vA;
		OrbitalObject(true, false, true, true, false, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		break;
	case  9:	//OE㉺ ړ
		MoveObject('H');
		OrbitalObject(false, true, true, true, true,  3);	MoveObject('S', IMG_FPS);	vA = -vA;
		OrbitalObject(false, true, true, true, false, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		break;
	case 10:	// ړ
		MoveObject('H');
		OrbitalObject(true, true, false, true, true,  3);	MoveObject('S', IMG_FPS);	vA = -vA;
		MoveObject("T");
		OrbitalObject(true, true, false, true, false, 3);	MoveObject('S', IMG_FPS);	vA = -vA;
		break;

	case 11:	//OEEE㉺ _ړ
		Randomize();
		vX = 4 * (Random(2)==0)? -1 : 1;
		vY = 4 * (Random(2)==0)? -1 : 1;
		vS = 1;
		RandomObject(total_stp);
		break;
	}

	X = Y = A = 0;
	S = minInterSize;

	//----------------------
	//S
	//----------------------
	OrgWinState 	  = WindowState;
	BorderStyle 	  = Forms::bsNone;
	Menu			  = NULL;
	OptPanel->Visible = false;
	WindowState 	  = wsMaximized;
	Screen->Cursor	  = crNone;

	//----------------------
	//Jn
	//----------------------
	ptrMotion		 = 0;
	Timer1->Interval = 42;
	Timer1->Enabled  = true;
	Timer2->Interval = 1000 * TimeEdit->Text.ToIntDef(180);
	Timer2->Enabled  = true;
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::StartActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !TimeEdit->Text.IsEmpty();

	IsChar			  = (ImgComboBox->ItemIndex>=4 && ImgComboBox->ItemIndex<=7);
	FontBtn->Enabled  = IsChar;
	CharEdit->Enabled = (ImgComboBox->ItemIndex==ImgComboBox->Items->Count-2);
	ImageBtn->Enabled = (ImgComboBox->ItemIndex==ImgComboBox->Items->Count-1);
}

//---------------------------------------------------------------------------
//I
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::Stop()
{
	Timer1->Enabled = false;
	Timer2->Enabled = false;

	//ʏ
	WindowState 	  = OrgWinState;
	BorderStyle 	  = bsSizeable;
	Menu			  = MainMenu1;
	OptPanel->Visible = true;
	Screen->Cursor	  = crDefault;

	TrackBar_S0Change(NULL);
	SetObjPos(0, 0, TrackBar_S0->Position, 0);
}

//---------------------------------------------------------------------------
//^C}[
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::Timer1Timer(TObject *Sender)
{
	TStringDynArray prm_lst = SplitString(MotionList->Strings[ptrMotion], ",");
	if (prm_lst[4]=="1") SetObjImg();
	SetObjPos(prm_lst[0].ToIntDef(0), prm_lst[1].ToIntDef(0), prm_lst[2].ToIntDef(0), prm_lst[3].ToIntDef(0));
	ptrMotion = (ptrMotion + 1)%MotionList->Count;
}
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::Timer2Timer(TObject *Sender)
{
	Stop();
}

//---------------------------------------------------------------------------
void __fastcall TParaTraForm::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (Key==VK_ESCAPE) Stop();
}

//---------------------------------------------------------------------------
//o[W
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::AboutItemClick(TObject *Sender)
{
	UnicodeString verstr;
	unsigned mj, mi, bl;
	if (GetProductVersion(Application->ExeName, mj, mi, bl)) {
		verstr.sprintf( _T("%u.%u%u"), mj,mi,bl);
	}

	AboutBox->Version->Caption	  = verstr;
	AboutBox->Copyright->Caption  = "2016 by Nekomimi";
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
//WebTCg
//---------------------------------------------------------------------------
void __fastcall TParaTraForm::WebItemClick(TObject *Sender)
{
	::ShellExecute(NULL, _T("open"), SUPPORT_URL,NULL,NULL,SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

